/*
 * GEXCEPT - Tests exception functions in gexcept
 * Copyright (C) 1999 Balazs Scheidler
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include "gexcept.h"

void recursive_fn(int n)
{
	if (n)
		recursive_fn(n - 1);
	G_THROW(2, "exception thrown by recursive_fn()", NULL);
}

int main()
{
	int state = 0;

	g_thread_init(NULL);
	g_exceptions_init();
	while (state != 2) {
		G_TRY {
			if (state == 0) G_THROW(1, "proba exception", NULL);
			if (state == 1) recursive_fn(10);
		}
		G_CATCH_START(ex) {
			G_CATCH(1) {
				g_exception_dump(ex);
				state++;
				break;
			}
			G_CATCH(2) {
				g_exception_dump(ex);
				state++;
				break;
			}
		}
		G_CATCH_END;
	}
	return 0;
}
